import { userData } from "../Classes/userData.js";
import { DatabaseController } from "../Database/dbcontroller.js";

export class users{
    static async createUser(db: DatabaseController, login : string, password : string){
        await db.run('INSERT INTO users (login, password) VALUES (?, ?)', [login, password]);
        return await this.readUser(db, login, password)
    }

    static async readUser(db: DatabaseController, login : string, password : string): Promise<userData>{
        let user = await db.select(`SELECT * FROM users WHERE login = ? AND password = ?`, [login, password])
        if (user.length > 0){
            let row = user[0]
            return new userData({...row})
        }
        else{
            return null
        }
    }

    static async readUserID(db: DatabaseController, id : number){
        let user = await db.select(`SELECT * FROM users WHERE id = ?`, [id])
        return user;
    }
}